/*
 * EpsilonClosure.h
 *
 *  Created on: 23. 3. 2014
 *	  Author: Tomas Pecka
 */

#ifndef EPSILON_CLOSURE_H_
#define EPSILON_CLOSURE_H_

#include <core/multipleDispatch.hpp>
#include <algorithm>
#include <deque>
#include <set>

#include "automaton/Automaton.h"
#include "automaton/AutomatonFeatures.h"
#include <label/Label.h>

namespace automaton {

namespace properties {

class EpsilonClosure : public std::SingleDispatch < EpsilonClosure, std::set<label::Label>, const automaton::AutomatonBase &, const label::Label&> {
public:
	static std::set<label::Label> epsilonClosure( const automaton::Automaton & automaton, const label::Label & state );

	/**
	 * Computes epsilon closure of a state in epsilon nonfree automaton
	 */
	static std::set<label::Label> epsilonClosure( const automaton::EpsilonNFA < > & fsm, const label::Label & state );
	static std::set<label::Label> epsilonClosure( const automaton::MultiInitialStateNFA < > & fsm, const label::Label & state );
	static std::set<label::Label> epsilonClosure( const automaton::NFA < > & fsm, const label::Label & state );
	static std::set<label::Label> epsilonClosure( const automaton::DFA < > & fsm, const label::Label & state );
	static std::set<label::Label> epsilonClosure( const automaton::ExtendedNFA < > & fsm, const label::Label & state );
	static std::set<label::Label> epsilonClosure( const automaton::CompactNFA < > & fsm, const label::Label & state );
};

} /* namespace properties */

} /* namespace automaton */

#endif /* EPSILON_CLOSURE_H_ */
