/*
 * GlushkovFirst.cpp
 *
 *  Created on: 14. 4. 2016
 *	  Author: Tomas Pecka
 */

#include "GlushkovFirst.h"

namespace rte {

std::set < std::ranked_symbol < > > GlushkovFirst::first ( const rte::FormalRTE < > & rte ) {
	return rte.getRTE ( ).getStructure ( ).accept < std::set < std::ranked_symbol < > >, GlushkovFirst::Formal > ( );
}

std::set < std::ranked_symbol < > > GlushkovFirst::Formal::visit ( const rte::FormalRTEAlternation < alphabet::Symbol, primitive::Unsigned > & node ) {
	std::set < std::ranked_symbol < > > ret, tmp;

	tmp = node.getLeftElement ( ).accept < std::set < std::ranked_symbol < > >, GlushkovFirst::Formal > ( );
	ret.insert ( tmp.begin ( ), tmp.end ( ) );

	tmp = node.getRightElement ( ).accept < std::set < std::ranked_symbol < > >, GlushkovFirst::Formal > ( );
	ret.insert ( tmp.begin ( ), tmp.end ( ) );

	return ret;
}

std::set < std::ranked_symbol < > > GlushkovFirst::Formal::visit ( const rte::FormalRTESubstitution < alphabet::Symbol, primitive::Unsigned > & node ) {
	std::set < std::ranked_symbol < > > ret, tmp;

	tmp = node.getLeftElement ( ).accept < std::set < std::ranked_symbol < > >, GlushkovFirst::Formal > ( );
	ret.insert ( tmp.begin ( ), tmp.end ( ) );

	 // First::Formal() returns a set. hence only one occurrence.
	auto it = std::find_if ( ret.begin ( ), ret.end ( ), [node] ( const std::ranked_symbol < > & a ) {
			return a == node.getSubstitutionSymbol ( ).getSymbol ( );
		} );

	if ( it != ret.end ( ) ) {
		ret.erase ( it );
		tmp = node.getRightElement ( ).accept < std::set < std::ranked_symbol < > >, GlushkovFirst::Formal > ( );
		ret.insert ( tmp.begin ( ), tmp.end ( ) );
	}

	return ret;
}

std::set < std::ranked_symbol < > > GlushkovFirst::Formal::visit ( const rte::FormalRTEIteration < alphabet::Symbol, primitive::Unsigned > & node ) {
	std::set < std::ranked_symbol < > > ret;

	ret = node.getElement ( ).accept < std::set < std::ranked_symbol < > >, GlushkovFirst::Formal > ( );
	ret.insert ( node.getSubstitutionSymbol ( ).getSymbol ( ) );
	return ret;
}

std::set < std::ranked_symbol < > > GlushkovFirst::Formal::visit ( const rte::FormalRTESymbolAlphabet < alphabet::Symbol, primitive::Unsigned > & node ) {
	return std::set < std::ranked_symbol < > > { node.getSymbol ( ) };
}

std::set < std::ranked_symbol < > > GlushkovFirst::Formal::visit ( const rte::FormalRTESymbolSubst < alphabet::Symbol, primitive::Unsigned > & node ) {
	return std::set < std::ranked_symbol < > > { node.getSymbol ( ) };
}

std::set < std::ranked_symbol < > > GlushkovFirst::Formal::visit ( const rte::FormalRTEEmpty < alphabet::Symbol, primitive::Unsigned > & /* node */ ) {
	return std::set < std::ranked_symbol < > > ( );
}

} /* namespace rte */
