/*
 * GlushkovPos.h
 *
 *  Created on: 14. 4. 2016
 *	  Author: Tomas Pecka
 */

#ifndef RTE_GLUSHKOV_POS_H_
#define RTE_GLUSHKOV_POS_H_

#include <rte/formal/FormalRTE.h>
#include <rte/RTEFeatures.h>

#include <alphabet/RankedSymbol.h>

namespace rte {

class GlushkovPos {
public:
	/**
	 * @return bool true if symbol pointer is in this subtree
	 */
	static bool pos ( const std::ranked_symbol < > & symbol, const rte::FormalRTE < > & node );

	class Formal {
	public:
		static bool visit ( const rte::FormalRTEAlternation < alphabet::Symbol, primitive::Unsigned > & node, const std::ranked_symbol < > & symbSearch );
		static bool visit ( const rte::FormalRTESubstitution < alphabet::Symbol, primitive::Unsigned > & node, const std::ranked_symbol < > & symbSearch );
		static bool visit ( const rte::FormalRTEIteration < alphabet::Symbol, primitive::Unsigned > & node, const std::ranked_symbol < > & symbSearch );
		static bool visit ( const rte::FormalRTESymbolAlphabet < alphabet::Symbol, primitive::Unsigned > & node, const std::ranked_symbol < > & symbSearch );
		static bool visit ( const rte::FormalRTESymbolSubst < alphabet::Symbol, primitive::Unsigned > & node, const std::ranked_symbol < > & symbSearch );
		static bool visit ( const rte::FormalRTEEmpty < alphabet::Symbol, primitive::Unsigned > & node, const std::ranked_symbol < > & symbSearch );
	};
};

} /* namespace rte */

#endif /* RTE_GLUSHKOV_POS_H_ */
