#include <list>
#include "minimizeTest.h"

#include "automaton/simplify/Minimize.h"

#define CPPUNIT_IMPLY(x, y) CPPUNIT_ASSERT(!(x) || (y))

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( minimizeTest, "automaton" );
CPPUNIT_TEST_SUITE_REGISTRATION( minimizeTest );

void minimizeTest::setUp() {
}

void minimizeTest::tearDown() {
}

void minimizeTest::testMinimize() {
  automaton::DFA < > automaton(label::Label(1));

  automaton.addState(label::Label(1));
  automaton.addState(label::Label(2));
  automaton.addState(label::Label(3));
  automaton.addInputSymbol(alphabet::Symbol("a"));
  automaton.addInputSymbol(alphabet::Symbol("b"));
  
  automaton.addTransition(label::Label(1), alphabet::Symbol("a"), label::Label(2));
  automaton.addTransition(label::Label(2), alphabet::Symbol("b"), label::Label(1));

  automaton.addFinalState(label::Label(3));
  
  automaton::DFA<> minimized = automaton::simplify::Minimize::minimize(automaton);

  CPPUNIT_ASSERT(minimized.getStates().size() == 3);

}
