#include <list>
#include "normalizeTest.h"

#include "automaton/simplify/Normalize.h"

#define CPPUNIT_IMPLY(x, y) CPPUNIT_ASSERT(!(x) || (y))

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( normalizeTest, "automaton" );
CPPUNIT_TEST_SUITE_REGISTRATION( normalizeTest );

void normalizeTest::setUp() {
}

void normalizeTest::tearDown() {
}

void normalizeTest::testNormalize() {
  automaton::DFA < > automaton(label::Label(0));

  automaton.addState(label::Label(0));
  automaton.addState(label::Label(1));
  automaton.addState(label::Label(2));
  automaton.addInputSymbol(alphabet::Symbol("a"));
  automaton.addInputSymbol(alphabet::Symbol("b"));
  
  automaton.addTransition(label::Label(0), alphabet::Symbol("a"), label::Label(1));
  automaton.addTransition(label::Label(1), alphabet::Symbol("b"), label::Label(2));

  automaton.addFinalState(label::Label(2));
  
  automaton::DFA<> normalized = automaton::simplify::Normalize::normalize(automaton);

  CPPUNIT_ASSERT(normalized.getStates().size() == 3);

  CPPUNIT_ASSERT(automaton == normalized);
}
